/'--------------------------------------------------------------------
               Nascent World Engine Map Editor for FreeBASIC              
                     Copyright Vincent DeCampo 2009      

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

--------------------------------------------------------------------'/
'
#Define Debug(x) Open cons For Output As #99:Print #99,x:Close #99

#Libpath "..\lib"
#Libpath "..\kwikgui\lib"

#Include "..\inc\nascentwe.bi"
#Include "..\kwikgui\inc\kwikgui.bi"

Type _DIALOGSELECT
   As Integer Cancel
   As Integer SizeX
   As Integer SizeY
   As String  StrReturn
End Type

Type _EditorSettings
   As Integer    MapWidth
   As Integer    MapHeight
   As String*255 Sheet(MaxSheetIdx)
End Type


#Define ScreenWidth  800
#Define ScreenHeight 600

Dim Shared As Integer gui_access
Dim Shared As Any Ptr gui_selection
Dim Shared As String  menu_selection

Declare Function MessageHandler(EventMsg As _EventMsg, EventData As _EventData) As Integer
Declare Function MoveCamera (tmEngine As _tmEngine) As Integer
Declare Function GetMapSize() As _DIALOGSELECT
Declare Function FileDialog(prompt As String="File Dialog", _
                            startpath As String = ".", _
                            pattern As String= "*.*") As _DIALOGSELECT

Declare Function GetFrameSelection (tmEngine As _tmEngine, ByRef lmapcell As _mapcell, ByRef rmapcell As _mapcell) As Integer

Declare Function LoadEditorSettings(filename As String) As _EditorSettings
Declare Sub      SaveEditorSettings(filename As String, As _EditorSettings) 

Declare Sub LoadSpritesToMap  ( dspSheet As _tmEngine, tmEngine As _tmEngine, sheet As Integer )
Declare Sub ProcessKeyboard   ( tmEngine As _tmEngine )
Declare Sub ProcessMouse      (tmEngine As _tmEngine, ByRef mx As Integer, ByRef my As Integer,lmapcell As _mapcell,rmapcell As _mapcell)
Declare Sub ProcessMouseAttr  (tmEngine As _tmEngine,ByRef mx As Integer, ByRef my As Integer,attr As Integer)
Declare Sub ShowAboutBox      ()
Declare Sub LoadSheet         (sheetnum As Integer, tmEngine As _tmEngine, dspSheet As _tmEngine,filename As String)

   ScreenRes ScreenWidth,ScreenHeight,32
   WindowTitle "Map Editor for NWE " + EngineVersion

/'

   Set Up KwikGUI Interface

'/
   Var GUI = _kGUI(0,0,ScreenWidth,ScreenHeight)      
   GUI.ForeColor = &hAA
   GUI.trans     = 1
   
   Dim cMenu As _kGUI_Control = _kGUI_Control(ctrlMENU, @MessageHandler)
   Dim cPlaceTile As _kGUI_Control = _kGUI_Control(ctrlRADIO, @MessageHandler)
   Dim cPlaceAttr As _kGUI_Control = _kGUI_Control(ctrlRADIO, @MessageHandler)
   Dim cPlaceAnim As _kGUI_Control = _kGUI_Control(ctrlRADIO, @MessageHandler)
   Dim cTileCoord As _kGUI_Control = _kGUI_Control(ctrlLABEL, @MessageHandler)
   Dim cNonBlock  As _kGUI_Control = _kGUI_Control(ctrlCHECKBOX, @MessageHandler)
   
   With cMenu
      .text =  "&File&&New&&Open&&Save&&---------&&Quit"+ _
               "&Load&&Sheet-1&&Sheet-2&&Sheet-3&&Sheet-4&&Sheet-5"+ _
               "&Edit&&Fill&&Fill/Tile&&Fill/Attr&&Replace"+ _
               "&Help&&About"               
      .tagname    ="Drop Down Menu"
      .backcolor  = &h661111
      .forecolor  = &hFFFFFF
      .sticky     = 0
      GUI.AddControl(@cMenu)
   End With   
   
   With cPlaceTile
      .x = 70
      .y = ScreenHeight-68
      .text = "Tile"
      .value = 1
      .forecolor = &hFFFFFF
      GUI.AddControl(@cPlaceTile)
   End With

   With cPlaceAttr
      .x = 130
      .y = ScreenHeight-68
      .text = "Attr"
      .forecolor = &hFFFFFF
      GUI.AddControl(@cPlaceAttr)
   End With
      
   With cPlaceAnim
      .x = 190
      .y = ScreenHeight-68
      .text = "Anim"
      .forecolor = &hFFFFFF
      GUI.AddControl(@cPlaceAnim)
   End With

   With cTileCoord
      .x = ScreenWidth-80
      .y = ScreenHeight-30
      .dx = 75
      .dy = 25
      .justify = 2
      .text = "x,y"
      .forecolor = &hFFFFFF
      GUI.AddControl(@cTileCoord)
   End With

   With cNonBlock
      .x = 130
      .y = ScreenHeight-45
      .size = 10
      .text = "Non-Blocking"
      .forecolor = &hFFFFFF
      GUI.AddControl(@cNonBlock)
   End With
   
'-------------------------------------------------------

/'

   Set Up Tile Map Engine
   
'/
   Dim As _tmEngine tmEngine = _tmEngine(ScreenWidth,ScreenHeight-104) 
   Dim As _tmEngine dspSheet = _tmEngine(640,480)
   Dim As _MapCell  lmapcell, rmapcell
   
   Dim As Integer mx,my,curimage,cursheet,dspmode
   Dim As _DIALOGSELECT DS
   
   Dim As _EditorSettings Settings
   
   tmEngine.Map.MakeMap(20,20)
   dspSheet.Map.MakeMap(20,20)
   tmEngine.Map.FillMap(0,0)
   
   Settings.MapWidth  = 20
   Settings.MapHeight = 20
      
   tmEngine.Sprites.LoadSheet(0,"images\default.bmp", TileWidth,TileHeight)
   dspSheet.Sprites.LoadSheet(0,"images\default.bmp", TileWidth,TileHeight)
      
   tmEngine.DesignMode = 1
    
   tmEngine.Map.BoundaryStyle = -1
   tmEngine.Map.BoundaryGrid  = 1 
   dspSheet.Map.BoundaryStyle = -1
   dspSheet.Map.BoundaryGrid  = 1 
      
	Do
		If tmEngine.GameClock.TickTime() Then
		   
   	   tmEngine.RenderMap
   	   tmEngine.RenderMask
   	   tmEngine.ShowMouse
   		
   		ScreenLock
   		   Line (0,0)-(ScreenWidth,ScreenHeight),&h909090,BF
   		   Select Case dspmode
   		      Case 0
         		   tmEngine.RenderSceneAt(0,26)
         		   GUI.Render()   		 

         		   tmEngine.Sprites.SheetPut(0,lmapcell.Sheet,10,ScreenHeight-40,lmapcell.Frame)
         		   tmEngine.Sprites.SheetPut(0,rmapcell.Sheet,44,ScreenHeight-40,rmapcell.Frame)
         		   
         		   cTileCoord.text = mx & "," & my
         		   Draw String (10,ScreenHeight-65),"Modify:"
         		   Draw String (ScreenWidth-40,ScreenHeight-65),Chr(24,25,26,27)		         
   		      Case 1 To 5
            	   dspSheet.RenderMap
            	   dspSheet.ShowMouse
   		         dspSheet.RenderSceneAt(ScreenWidth/2-320,ScreenHeight/2-240)
   		         Draw String (10,10),"Sprite Sheet #" & dspMode
   		         Draw String (10,20),"Filename:" & Settings.Sheet(dspMode-1)
   		   End Select   		
   		ScreenUnlock
		
		   GUI.ProcessEvents
		         
         If gui_access = 0 Then
            Dim As Integer newAttr
            If cNonBlock.value Then 
               newAttr = newAttr Or tmEngine.Map.mapNONBLOCKING
            EndIf
            lmapcell.attr = newAttr
            rmapcell.attr = newAttr
            Select Case dspMode
               Case 0
                  If cPlaceTile.value Then
                     ProcessMouse    ( tmEngine,mx,my,lmapcell,rmapcell )
                  End If
                  If cPlaceAttr.value AndAlso cNonBlock.value Then
                     ProcessMouseAttr( tmEngine,mx,my,newAttr)
                  EndIf 
                  ProcessKeyboard ( tmEngine )
                  MoveCamera      ( tmEngine )
               Case 1 To 5
                  Select Case GetFrameSelection ( dspSheet, lmapcell, rmapcell )
                     Case 1
                        lmapcell.Sheet = dspMode-1
                     Case 2
                        rmapcell.Sheet = dspMode-1
                  End Select                                   
            End Select
         End If

         Select Case UCase(menu_selection)
            Case "ABOUT"
               ShowAboutBox 
            Case "SAVE"
               tmEngine.Map.SaveMap("mapedit.dat")
               SaveEditorSettings("mapedit.set",Settings)
            Case "OPEN"
               settings = LoadEditorSettings("mapedit.set")
               tmEngine.Map.LoadMap("mapedit.dat",settings.MapWidth,settings.MapHeight)
               For sh As Integer = 0 To MaxSheetIdx
                  If Len( Settings.Sheet(sh) ) Then
                     LoadSheet ( sh,tmEngine,dspSheet,Settings.Sheet(sh) )
                  EndIf
               Next
            Case "NEW"
               DS = GetMapSize()
               If DS.Cancel=0 Then
                  tmEngine.Map.MakeMap(DS.SizeX,DS.SizeY)
                  tmEngine.Map.FillMap(0,0)
                  tmEngine.Camera.x = 0
                  tmEngine.Camera.y = 0
                  Settings.MapWidth  = DS.SizeX
                  Settings.MapHeight = DS.SizeY
               EndIf
            Case "FILL"
               Dim As Integer Attr
               If cNonBlock.value Then Attr Or= tmEngine.Map.mapNONBLOCKING
               tmEngine.Map.FillMap(lmapcell.Frame,lmapcell.Sheet, Attr)               
            Case "FILL/TILE"
               tmEngine.Map.FillMap(lmapcell.Frame,lmapcell.Sheet)
            Case "FILL/ATTR"
               Dim As Integer Attr
               If cNonBlock.value Then Attr Or= tmEngine.Map.mapNONBLOCKING
               tmEngine.Map.FillMap(,, Attr)
            Case "QUIT"
               Exit Do
            Case "SHEET-1" 
               DS = FileDialog("Load Sprite Sheet #1",,"*.bmp")
               If DS.Cancel=0 Then
                  LoadSheet ( 0,tmEngine,dspSheet,DS.StrReturn )
                  Settings.Sheet(0) = DS.StrReturn
               End If
            Case "SHEET-2" 
               DS = FileDialog("Load Sprite Sheet #2",,"*.bmp")
               If DS.Cancel=0 Then
                  LoadSheet ( 1,tmEngine,dspSheet,DS.StrReturn )
                  Settings.Sheet(1) = DS.StrReturn
               End If
            Case "SHEET-3" 
               DS = FileDialog("Load Sprite Sheet #3",,"*.bmp")
               If DS.Cancel=0 Then
                  LoadSheet ( 2,tmEngine,dspSheet,DS.StrReturn )
                  Settings.Sheet(2) = DS.StrReturn
               End If
            Case "SHEET-4" 
               DS = FileDialog("Load Sprite Sheet #4",,"*.bmp")
               If DS.Cancel=0 Then
                  LoadSheet ( 3,tmEngine,dspSheet,DS.StrReturn )
                  Settings.Sheet(3) = DS.StrReturn
               End If
            Case "SHEET-5" 
               DS = FileDialog("Load Sprite Sheet #5",,"*.bmp")
               If DS.Cancel=0 Then
                  LoadSheet ( 4,tmEngine,dspSheet,DS.StrReturn )
                  Settings.Sheet(4) = DS.StrReturn
               End If               
         End Select
         
		End If

      dspMode = 0
      gui_selection  = 0
      menu_selection = ""

      For ky As Integer = 0 To 4
         If MultiKey(FB.SC_1+ky) Then
            dspMode = 1+ky
            LoadSpritesToMap ( dspSheet, tmEngine,ky )
         EndIf
      Next
      
		Sleep 1,1
		
	Loop Until MultiKey(fb.SC_ESCAPE)

Sub LoadSheet (sheetnum As Integer, tmEngine As _tmEngine, dspSheet As _tmEngine,filename As String)

   tmEngine.Sprites.LoadSheet(sheetnum,filename,TileWidth,TileHeight)
   dspSheet.Sprites.LoadSheet(sheetnum,filename,TileWidth,TileHeight)

End Sub

Sub LoadSpritesToMap ( dspSheet As _tmEngine, tmEngine As _tmEngine, sheet As Integer )
Dim As Integer  frame
Dim As _MapCell mapcell

   dspSheet.Map.MakeMap ( tmEngine.Sprites.Sheet(sheet).Cols, _
                          tmEngine.Sprites.Sheet(sheet).Rows )
   
   For row As Integer = 0 To tmEngine.Sprites.Sheet(sheet).Rows - 1
      For col As Integer = 0 To tmEngine.Sprites.Sheet(sheet).Cols - 1
         mapcell = dspSheet.Map.BuildCell(frame,sheet,0,0)
         dspSheet.Map.SetCell( col,row, mapcell )
         frame+=1
      Next
   Next
   
End Sub

Sub ProcessMouse (tmEngine As _tmEngine,ByRef mx As Integer, ByRef my As Integer,lmapcell As _mapcell,rmapcell As _mapcell)
Dim As Integer wh,btn,clip

   GetMouse mx,my,wh,btn
   tmEngine.GetMouseTile(mx,my)
   Select Case btn
      Case 1
         'Convert mouse coord to tile coords
         tmEngine.Map.SetCell(mx,my,lmapcell)
      Case 2
         'Convert mouse coord to tile coords
         tmEngine.Map.SetCell(mx,my,rmapcell)
   End Select
   
End Sub

Sub ProcessMouseAttr (tmEngine As _tmEngine,ByRef mx As Integer, ByRef my As Integer,attr As Integer)
Dim As Integer wh,btn,clip
Dim As _MapCell mapcell

   GetMouse mx,my,wh,btn
   tmEngine.GetMouseTile(mx,my)
  
   Select Case btn
      Case 1
         'Convert mouse coord to tile coords
         mapcell = tmEngine.Map.GetCell(mx,my)
         mapcell.Attr Or= attr
         tmEngine.Map.SetCell(mx,my,mapcell)
      Case 2
         'Convert mouse coord to tile coords
         mapcell = tmEngine.Map.GetCell(mx,my)
         mapcell.Attr = 0
         tmEngine.Map.SetCell(mx,my,mapcell)
   End Select
   
End Sub

Function GetFrameSelection (tmEngine As _tmEngine, ByRef lmapcell As _mapcell, ByRef rmapcell As _mapcell) As Integer
Dim As Integer mx,my,wh,btn,clip

   GetMouse mx,my,wh,btn
   tmEngine.GetMouseTile(mx,my)
   Select Case btn
      Case 1
         'Convert mouse coord to tile coords
         lmapcell = tmEngine.Map.GetCell(mx,my)
         Return 1 
      Case 2
         'Convert mouse coord to tile coords
         rmapcell = tmEngine.Map.GetCell(mx,my)
         Return 2
   End Select
   
End Function

Sub ProcessKeyboard(tmEngine As _tmEngine)
   
	If MultiKey(fb.SC_F1) Then 
		tmEngine.Map.SaveMap("map.dat")
	EndIf

End Sub

Function MoveCamera(tmEngine As _tmEngine) As Integer

   With tmEngine.Camera
   	If MultiKey(fb.SC_LEFT) Then 
   		.MoveLeft(.2)
   	EndIf
   	If MultiKey(fb.SC_RIGHT) Then 
   		.MoveRight(.2)
   	EndIf	
      '---------------------------------------------         
   	If MultiKey(fb.SC_UP) Then 
   		.MoveUp(.2)
   	EndIf
   	If MultiKey(fb.SC_DOWN) Then 
   		.MoveDown(.2)
   	EndIf
   End With
   
   Return 1
   
End Function

Function MessageHandler(EventMsg As _EventMsg, EventData As _EventData) As Integer
Dim As _kGUI_Control Ptr Ctrl = Cast(_kGUI_Control Ptr, EventData.Ctrl)
Dim As _kGUI Ptr GUI = Cast(_kGUI Ptr, EventData.GUI)

   With *Ctrl
      Select Case EventMsg
         Case Mouse_Over
         Case Mouse_Click
            gui_selection = Ctrl
         Case Mouse_DblClick
         Case Mouse_Down
            gui_access = 1
         Case Mouse_Up
            gui_access = 0
         Case Ctrl_GotFocus
         Case Ctrl_LostFocus
         Case Timer_Event
         Case Menu_Select
            menu_selection = Ctrl->seltext
         Case Combo_Select
         Case Slider_Scroll
         Case Ctrl_Refresh
         Case Key_Press
      End Select
   End With
   
   Return 0
   
End Function

Function GetMapSize() As _DIALOGSELECT
Dim GUI As _kGUI_Design = _kGUI_Design("forms\mapsize.kwk",@MessageHandler)
Dim As _DIALOGSELECT DS
      
   'This is how we change properties on GUI design
   '-----------------------------------------------
   Var txtWidth  = GUI.GUI->FindControl("txtWidth")
   Var txtHeight = GUI.GUI->FindControl("txtHeight")
   Var btnOK     = GUI.GUI->FindControl("btnOK")
   Var btnCANCEL = GUI.GUI->FindControl("btnCANCEL")
   '----------------------------------------------

   'Make some GUI adjustments
   GUI.GUI->CenterMe
      
   Do
      ScreenLock
         Cls
         GUI.GUI->ProcessEvents
         GUI.GUI->Render
      ScreenUnlock
      
      Select Case gui_selection
         Case btnOK
            DS.SizeX  = Val(txtWidth->text)
            DS.SizeY  = Val(txtHeight->text)
            DS.Cancel = 0
            Exit Do            
         Case btnCANCEL
            DS.Cancel = 1
      End Select             
            
      gui_selection  = 0
      menu_selection = ""
      
   Loop Until DS.Cancel

   Return DS

End Function

Function FileDialog(prompt As String="File Dialog", _
                    startpath As String = ".", _
                    pattern As String= "*.*") As _DIALOGSELECT
                    
Dim GUI As _kGUI_Design = _kGUI_Design("forms\filedlg.kwk",@MessageHandler)
Dim As _DIALOGSELECT DS

   'This is how we change properties on GUI design
   '-----------------------------------------------
   Var titlebar  = GUI.GUI->FindControl("titlebar")
   Var dirlist   = GUI.GUI->FindControl("dirlist")
   Var filelist  = GUI.GUI->FindControl("filelist")
   Var btnOK     = GUI.GUI->FindControl("btnOK")
   Var btnCANCEL = GUI.GUI->FindControl("btnCANCEL")
   '----------------------------------------------

   'Make some GUI adjustments
   GUI.GUI->CenterMe

   titlebar->text = prompt & " - " & pattern
   dirlist->path  = startpath
   filelist->path = startpath
   filelist->pattern = pattern
   filelist->refresh
        
   Do
      ScreenLock
         Cls
         GUI.GUI->ProcessEvents
         GUI.GUI->Render
      ScreenUnlock
      
      Select Case gui_selection
         Case btnOK
            DS.Cancel = 0
            Exit Do            
         Case btnCANCEL
            DS.Cancel = 1
         Case dirlist
            filelist->path = dirlist->path
            filelist->refresh
         Case filelist
            DS.StrReturn = dirlist->path & "\" & filelist->text
            titlebar->text = prompt & " - " & filelist->text
      End Select             
            
      gui_selection  = 0
      menu_selection = ""
      
   Loop Until DS.Cancel

   Return DS

End Function

Sub ShowAboutBox ()
Dim GUI As _kGUI_Design = _kGUI_Design("forms\aboutdlg.kwk",@MessageHandler)

   GUI.GUI->CenterME

   'This is how we change properties on GUI design
   '-----------------------------------------------
   Var btnOK     = GUI.GUI->FindControl("btnOK")

   Do
      ScreenLock
         Line (0,0)-(ScreenWidth,ScreenHeight),&h909090,BF
         GUI.GUI->ProcessEvents
         GUI.GUI->Render
      ScreenUnlock
      
      Select Case gui_selection
         Case btnOK
            Exit Do            
      End Select
   
   Loop
   
End Sub

Function LoadEditorSettings(filename As String) As _EditorSettings
Dim As _EditorSettings tmp
Dim As Integer hf = FreeFile

   Open filename For Binary As hf
      Get #hf,,tmp
   Close #hf
   
   Return tmp
   
End Function
   
Sub SaveEditorSettings(filename As String, tmp As _EditorSettings) 
Dim As Integer hf = FreeFile

   Open filename For Binary As hf
      Put #hf,,tmp
   Close #hf
   
End Sub

