/'--------------------------------------------------------------------
                  Nascent World Engine for FreeBASIC              
                     Copyright Vincent DeCampo 2009      

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

--------------------------------------------------------------------'/

Constructor _Sound
' FBS_Init( [playbackrate in Hz.] optional default 44100
'          ,[number of channels]  optional default 2
'          ,[number of buffers]   optional default 3
'          ,[frames per buffer]   optional default 2048
'          ,[nDevice]             optional default 0 = first) as FBSBOOLERAN

   this.InitOK = fbs_Init()
      
End Constructor
Destructor _Sound
   fbs_exit()   
End Destructor

Function _Sound.LoadWave(filename As String, index As Integer) As Integer
Dim As Integer hWave,hSound
   
   If fbs_Load_WAVFile(filename,@hWave) Then
      fbs_Create_Sound(hWave,@hSound)    
      this.Sounds(index)=hSound
      Return 1
   EndIf
   
End Function

Function _Sound.LoadMP3(filename As String, index As Integer) As Integer
Dim As Integer hWave,hSound
   
   If fbs_Load_MP3File(filename,@hWave) Then
      fbs_Create_Sound(hWave,@hSound)    
      this.Sounds(index)=hSound
      Return 1
   EndIf
   
End Function

Function _Sound.PlaySound(index As Integer, loops As Integer=1) As Integer
   fbs_Play_Sound this.Sounds(index), loops
   Return loops
End Function

Function _Sound.GetVolume(index As Integer) As Single
Dim As Single svolume
   Return fbs_get_soundvolume(this.Sounds(index), @svolume) 
End Function

Sub _Sound.SetVolume(index As Integer, svolume As Single)
   fbs_set_soundvolume(this.Sounds(index),svolume)
End Sub

Function _Sound.GetLoops(index As Integer) As Integer
Dim As Integer nloops   
   fbs_get_soundloops(this.Sounds(index),@nloops)
   Return nloops
End Function

Sub _Sound.SetLoops(index As Integer, nloops As Integer=1)
   fbs_Set_SoundLoops(this.Sounds(index),nloops)
End Sub

Function _Sound.Pause(index As Integer, paused As Integer=1) As Integer
   Return fbs_set_soundpaused (this.Sounds(index), paused)
End Function
